Welcome to XC Reports Scheduler

XConnect is Sutron Corporation's latest data collection, data processing and data storage software. Built on the strong principles of PcBase2, XConnect is compliant with today's 32-bit Windows operating systems and provides new tools and options for the user.

XConnect is a collection of executables designed to provide a complete solution for data collection, data handling, data viewing and data storage

The XC Reports Scheduler provides the convenience to the user of automatically generating commonly used reports on a user-defined schedule. Typically, diagnostic reports will be run every morning to assess the RTU network. The XC Reports Scheduler can run the report prior to your arrival at work and have it ready.

XC Reports Scheduler works with XC Reports. It reads in the report library from XC Reports and automatically generates reports to files or printers based on the schedule.

XConnect is installed with an array of reports displaying system, data and diagnostic data. XC Reports Scheduler is designed for the database storage option in XConnect. Using the power of Crystal Reports to generate new reports, XConnect now has the mechanism to add new reports easily to its library to fill the demands of changing customer requirements.

Copyright © 2003 - 2006 Sutron Corporation. All rights reserved.


Moving around in XC Reports Scheduler

The XC Reports Scheduler application consists of these main areas:

  • The Menu Bar provides access to all user-controllable functions within the application.

  • The Toolbar provides one-click access to important functions.

  • The Status Window provides error messages, warning messages and status messages generated by the application.

  • The Detail Panel controls the messages displayed in the status window.

  • The Status Bar displays parameter hints

Click an area on the image below for more information.

Copyright © 2003 - 2006 Sutron Corporation. All rights reserved.


Changing the database source

XC Reports Scheduler displays the data from a database. Easily the database can be changed, as long as it is defined in the Data Sources (ODBC) control applet. To change data sources:

  1. Start XC Reports Scheduler from the Start Menu or from a desktop icon.

  2. From the Database menu, select Disconnect or from the toolbar click on the [image] icon to disconnect from the current data source.

  3. Next, from the Database menu, select Connect or from the toolbar click on the [image] icon to select a new data source.

  4. The XC Report Scheduler Database Login window will appear.

  5. Click on the Database Alias list box to select the new data source.

  6. Enter User Name and Password for data source and click OK.

  7. XC Reports will attempt to connect to selected data source using the user name and password entered.


The lower case letters "yy", "yyyy", "mm, "dd", "hh", "mi" can be included in the name to instruct the software to created separate minute, hourly, daily, monthly, or yearly files. Optionally, "#nn: can be added to specify that a new file should be created every nn minutes (when using "mi") or hours (when using "hh"), or days (all other). The "#nn" can appear anywhere in the string, where nn must be two digits with leading zeros, if necessary.

The dating of output files is important for easy backup, purging or distribution of output files.

Example 1:

MYDATdd.TXT would create the file MYDAT01.TXT on the first day of the month, MYDAT02.RAW on the second day, and so on until the next month MYDAT01 would be used again. NESmm.TXT would create the file NES01.TXT to contain all the data for January, NES02.TXT to contain all the data for February, and so on until the next month.

Example 2:

yymmddhh.CSV#02 would create a new output file every 2 hours. If the "#02" was left off, a new file would be created every hour. As well, mmddhhmi.CSV#15 would create a new output file every 15 minutes.

Creating a new Report Group

Follow these steps to create a new report group.

  1. Click the XC Report Scheduler icon on the desktop. The XC Report Scheduler application starts.

  2. From the Options menu, select Edit Setup Parameters or from the toolbar click on the [image] icon.

  3. The Setup window will appear.

  4. Click on the New button to create a new report group. XC Report Scheduler will automatically assign the next available report group number. The first Poll group will be 1. The poll group number will increment automatically as you add more report groups. Right clicking on the Poll Group list and clicking on the New menu option will also create new poll groups.

  5. Check Enable so that this report group will be run on schedule. By default, Enable is not checked.

  6. First, select an available report from the list by click [image]. A new dialog will appear and select the report from the list.

  7. Next, set the Base Time and Interval for the report group. The Base Time represents an offset into the hour. The Interval sets the time between reports. It must be greater than zero. As an example, if the Base Time is 00:05:00 and Interval is 00:30:00, then XC Report Scheduler will execute the report group for data 00:05:00, 00:35:00, 01:05:00, 01:35:00...etc.

  8. Select the Output format. It can be Printer or File.

  9. If Printer is selected, select the printer from the combo box.

  10. If File is select, specify the Output Dir and Name: Here, you can Browse for the directory. The output file can be named with the date and time as well. Tips on file name convention [image] .

  11. Go to Params tab.

  12. Specify Start, which define the start date and time for report data. The Start field will automatically be updated to the date and time of the last data received.

  13. Add site-sensor combinations to the Site-sensor list box. Click or highlight a site/station in the Sites list box. The sensors associated with the site will be displayed in the Sensors list box. Add the site-sensor combination by double clicking on the sensor or highlighting the sensor and click the Add button. It is possible to select multiple sensors and add all of them to the Site-sensor list. You can also remove the site-sensor combination by clicking on the Remove button.

  14. Click Save button to save all poll group changes. This is very important. You can also right click and select the Save menu option to save the poll group details.

  15. You can now do a test run by manually executing the report group.


The lower case letters "yy", "yyyy", "mm, "dd", "hh", "mi" can be included in the name to instruct the software to created separate minute, hourly, daily, monthly, or yearly files. Optionally, "#nn: can be added to specify that a new file should be created every nn minutes (when using "mi") or hours (when using "hh"), or days (all other). The "#nn" can appear anywhere in the string, where nn must be two digits with leading zeros, if necessary.

The dating of output files is important for easy backup, purging or distribution of output files.

Example 1:

MYDATdd.TXT would create the file MYDAT01.TXT on the first day of the month, MYDAT02.RAW on the second day, and so on until the next month MYDAT01 would be used again. NESmm.TXT would create the file NES01.TXT to contain all the data for January, NES02.TXT to contain all the data for February, and so on until the next month.

Example 2:

yymmddhh.CSV#02 would create a new output file every 2 hours. If the "#02" was left off, a new file would be created every hour. As well, mmddhhmi.CSV#15 would create a new output file every 15 minutes.

Report Group Setup parameters

In setting up XC Report Scheduler, report groups must be defined. These report groups are comprised of report schedule, sites and sensors based on some defined selection criteria (e.g. all sites with the rain gauge sensor, or all sites in a particular basin or latitude etc.). The sites and sensors belonging to a report group are all polled for data from the database at the same time and then displayed in the report. To set these parameters:

  1. Click the XC Report Scheduler icon on the desktop. The XC Report Scheduler application starts.

  2. From the Options menu, select Edit Setup Parameters or from the toolbar click on the [image] icon.

  3. The Setup parameters window will appear.

From this window you can create and make changes to all report groups. When you are finished, click the Save button to save changes. Clicking Close will only close the window without saving changes.

Report Group parameters

  • Groups - List of current report groups. Select from the list to display the report group parameters associated with the group.

  • New - Click this button to create/add an report group. The first poll group will be 1. The report group number will increment automatically as you add more report groups. Right clicking on the report group list and clicking on the New menu option will also create new report groups.

  • Delete - Click this button to delete the currently displayed report group.

  • Delete All - Click this button to delete all report groups. Use with caution!

  • Save - Click this button to save all report parameters for currently displayed report group.

  • Enable - This flag indicates the poll group is active and ready to be polled/run. Poll groups can be created but left "inactive" until a later date.

  • Report: Select an available report from the XC Reports library by clicking [image]. A new dialog will appear and select the report from the list.

  • Schedule Tab

    • Base Time - Used in conjunction with the Interval, this indicates how often XC Report Scheduler will dispatch the report groups and run the reports. The Base Time represents an offset into the hour. As an example, if the Base Time is 00:05:00 and Interval is 00:30:00, then XC Report Scheduler will run report groups at 00:05:00, 00:35:00, 01:05:00, 01:35:00...etc.

    • Interval - Used in conjunction with the Base Time, this indicates how often XC Report Scheduler will dispatch the report group and run the reports. The Interval represents how often the report is run. As an example, if the Base Time is 00:05:00 and Interval is 00:30:00, then XC Report Scheduler will run reports at 00:05:00, 00:35:00, 01:05:00, 01:35:00...etc.

    • Run - An optional list of programs to run when the report group is completed. If the application does not reside in the XConnect home directory, list the file path with the executable name (i.e., c:\myapp\myapp.exe). Parameters to be passed to the program must be in double quotes (i.e., Notepad “MyExport.txt”).

    • Output - This indicates the output for the reports. It can be either Printer or File.

    • Printer - If output is printer, select the printer for the reports. Click Setup to choose printer setup params.

    • Output Dir - If output is file, select the output directory. This is the directory to store all report files.

    • Name - Specify the output filename or filename pattern for the exported data. Using the filename pattern, the output file can be named with the date and time as well. Tips on file name convention [image] .

    • Format - Specify output file format. This can be PDF, XLS, HTML, WORD, CSV and XML.

  • Params Tab

    • Start Time - Specify start time for requesting data from the database. The Start field will automatically be updated to the date and time of the last report is run.

    • Time Range - Specify the start time and end time for the report if those params are required in the configuration of the report.

    • Sites and Sensors- List of sites and sensors available in database. The control will be enabled if the report need sites and sensors parameters.

    • Add - Click this button to add the highlighted site-sensor pair to the Sites-Sensors Selected list box. Only sensors listed here will be exported from the database. Double-clicking on the sensor name will also add the site-sensor pair.

    • Remove - Click this button to remove the highlighted site-sensor pair from the Sites-Sensors Selected list box.

    • Sites-Sensors Selected - List of sensor that will be used in this report group.

    • Custom Params - If in the report selected, there are any unrecognized user-defined parameters, they will be listed in this list. Click on the right site to enter the values, so that it will be passed to the report alone with other parameters [image] .


Copying a Report Group

Follow these steps to create a new report group.

  1. Click the XC Report Scheduler icon on the desktop. The XC Report Scheduler application starts.

  2. From the Options menu, select Edit Setup Parameters or from the toolbar click on the [image] icon.

  3. The Setup window will appear.

  4. Select the Group Index from Groups box.

  5. Click Copy to copy the current report group. The new group will have a new group index and be displayed as current report group.


Deleting a Report Group

Follow these steps to create a new report group.

  1. Click the XC Report Scheduler icon on the desktop. The XC Report Scheduler application starts.

  2. From the Options menu, select Edit Setup Parameters or from the toolbar click on the [image] icon.

  3. The Setup window will appear.

  4. Select the Group Index from Groups box.

  5. Click Delete to drop the current report group.


Manually Start Process Now

XC Report Scheduler will automatically run the reports based on the Base Time and Interval of the active report groups. However, if the user does not want to wait for the Next Report Time as displayed in the detail panel of the status window, the user can trigger any report group at any time. To trigger an on-demand process:

  1. Click the XC Report Scheduler icon on the desktop. The XC Report Scheduler application starts.

  2. From the Process menu, select Start Process Now or from the toolbar click on the [image] icon.

  3. The Select Groups window will appear.

  4. Select desired report group number to manually trigger and click Ok.


Stopping Process

XC Report Scheduler will stop all active report groups that are running and wait to the next report scheduler if Stop Process is used:

  1. From the Process menu, select Stop Process or from the toolbar click on the icon [image].


Status messages

XC Report Scheduler confirms the user would like to disconnect from the current database source. Disconnecting from a data source prevents any reports from being run.

XC Report Scheduler is attempting to connect to the database (ODBC) source.

XC Report Scheduler has successfully connected to the user selected database (ODBC) source.

XC Report Scheduler confirms the user would like to save all the parameters.

XC Report Scheduler confirms the user would like to remove the report group.

XC Report Scheduler confirms the user would like to remove all the report groups.

XC Reports has disconnect from the current database (ODBC) source.

All raw files have been checked for new satellite messages and decoded.

XC Reports is reading the default configuration file which contains user's last program settings.

XC Report has complete reading and applying all the startup parameters and is ready to generate reports.

XC Report has started a new thread to process the report for group xxx and report name yyy.

XC Report has opened the report file for group xxx.

XC Report has set the output of report group xxx to printer.

XC Report has set the output of report group xxx to file.

XC Report is ready to run the report with the parameters and output defined in report group.

XC Report is finished process the report.

The thread used to run the report has been stopped for group xxx and report name yyyy.

The thread used to run the report has been freed for group xxx and report name yyyy.

Status messages

Below are the status messages XC Decode will display in the decoding status window as it decodes data from the raw files:

  • Are you sure you would like to disconnect from current ODBC source?

  • Connecting to database...

  • Connected to database ODBC source.

  • Save all current parameters?

  • Are you sure you want to delete this group?

  • Are you sure you want to delete all the Groups?

  • Disconnected from database.

  • Database NOT connected.

  • Reading xxx.XFG.

  • Startup parameters loaded.

  • Thread started. Group: xxx Report Name: yyyy

  • Open report files. Group: xxx

  • Output to printer. Group: xxx

  • Output to file. Group: xxx

  • Now ready to run the report.

  • Finish the report.

  • Thread stopped. Group: xxx Report Name: yyyy

  • Thread freed. Group: xxx Report Name: yyyy


Logging status messages

The purpose of the Log Status Messages is for troubleshooting. Logging all messages, will provide Sutron customer support a historical log of all events to help troubleshoot any problems. To log all status messages:

  1. Click the XC Report Scheduler icon on the desktop. The XC Report Scheduler application starts.

  2. From the Options menu, select Log Status Messages or from the toolbar click on the [image] icon. XCRptSchedule.log will be used to append status messages.


Troubleshooting tips

Network errors can potentially be the source of most errors in XC Report Scheduler. In most cases, databases are stored on separate network servers. If a sudden loss of network connectivity should occur, reports will fail to generate. Ensure network access is available to the network database server as well as the correct login privileges. Again, in a large network where the database is on a separate server, verify your database login name and password with you network administrator.

On small systems using Access as you database, the Access database (.MDB) may or may not be stored in the same PC. Make sure, for all Data Sources configurations, the data source is configured as a system resource (System DSN) and not as a user resource. Access, based on the data source configuration, may or may not require a password. Verify any login parameters.

There is a chance that the Crystal Report file (.RPT) may become corrupt. If so, the user can copy or re-install the file from the XConnect installation CD.


Error messages

Troubleshooting steps:

Ensure that:

  • Current XConnect application is part of the purchased XConnect license.

Refer to the original purchase order.

Troubleshooting steps:

Potential reasons for error:

  • Current XConnect application is not valid for use with existing XConnect license.

Call Sutron Sales to upgrade XConnect license.

Troubleshooting steps:

If any error happens during the process of the report, this error may be shown with a detailed error message appended.

Potential reasons for error:

  • The database configuration has changed on the current machine/network PC or has XConnect been installed on a new PC where the Data Source is not configured.

Verify the Data Source (ODBC) settings for XConnect database.

Check settings in Data Sources control applet either in the Control Panel or in Administrative Tools.

Verify user name and password are correct for database login.

  • Report file is missing or corrupt.

The report engine in XC Report Scheduler can not read in the report, either because it's missing or the file is corrupt. Please verify the report file.

Troubleshooting steps:

Potential reasons for error:

  • The parameter is expecting a number, but the input can not be converted to the number. Please verify the input parameters.

Troubleshooting steps:

Potential reasons for error:

  • XC Report Scheduler can not connect to the database. Please verify the network connection, user name, password and database status.

Troubleshooting steps:

Potential reasons for error:

  • XC Report Scheduler can not set the Crystal Report file's parameters. It could be the corrupt report file or unsupported version of report. Please verify the report file.

Troubleshooting steps:

Potential reasons for error:

  • The Crystal Report file is expecting certain parameters, but it's not found in the setups. Please check the report group parameters again.

Troubleshooting steps:

Potential reasons for error:

  • This error is displayed if you are trying to manually run the report group without first enabled it. Please enable the report group in setups.

Troubleshooting steps:

Potential reasons for error:

  • After completing the report, it is trying to run the programs that are defined on the Run line. But they couldn't be found. Check the program Run line and path.

Troubleshooting steps:

Potential reasons for error:

  • After completing the report, it is trying to run the programs that are defined on the Run line. But the programs returns any error code back to XC Report Scheduler.

Error Messages

Potential error messages generated by XC Reports are:

Error 8: Invalid License Key. Please verify XConnect is properly installed.

Error 9: Invalid License Key. Exiting now...

Error 1700: General Report Error.

Error 1701: Value is not a number.

Error 1702: Unable to connect to database - XConnect.

Error 1703: Unable to set Crystal Reports run parameters.

Error 1704: Param not defined. Check setup again.

Error 1705: Report not enabled.

Error 1706: Run file BatchFile does not exist.

Error 1707: Error running program BatchFile.

Copyright © 2003 - 2006 Sutron Corporation. All rights reserved.


Detail Panel

The Detail Panel

The Detail panel shows the next report group and allows the user to control the level of messages displayed in the status windows.

The Next Group and Next Time fields show the next scheduled export poll group and the time the poll group will trigger.

Message Detail options are:

  • Low - indicates only error messages will be displayed.

  • Med - indicates error messages, warning messages and brief status messages will be displayed.

  • High - indicates all messages will be displayed. In High detail, actual retrieved values and their corresponding time stamps will be displayed.

Detail level: Low only errors are displayed

Error messages are usually caused by the database being offline, or by a network file server error. If the database is offline then no data will be exported. However, the program will try to connect again to the database the next time data export is due.

Detail level: Medium errors, warnings and are important messages are displayed

Warning messages usually result if there was no data found for the date and time specified.

9/9/2004 4:19:54 PM Connected to database XConnect.

9/9/2004 4:19:51 PM Startup parameters loaded.

Detail level: High errors, warnings and status messages are displayed

9/9/2004 5:03:53 PM Thread freed. Group: 2 Report Name: 023 Data For Selected Time Range-Stations-Sensors

9/9/2004 5:03:52 PM Thread stopped. Group: 2 Report Name: 023 Data For Selected Time Range-Stations-Sensors

9/9/2004 5:03:51 PM Finish the report.

9/9/2004 5:03:51 PM Now ready to run the report.

9/9/2004 5:03:51 PM File Name: C:\Temp\023.DOC

9/9/2004 5:00:44 PM Output to file. Group: 2 Report Name: 023 Data For Selected Time Range-Stations-Sensors

9/9/2004 5:00:05 PM Open report files. Group: 2 Report Name: 023 Data For Selected Time Range-Stations-Sensors

9/9/2004 5:00:04 PM Thread started. Group: 2 Report Name: 023 Data For Selected Time Range-Stations-Sensors


Menu Bar

The Menu Bar

The Menu Bar provides access to the following menus:

File

  • Exit -- terminates the application.

Database

  • Connect -- opens a dialog box to select database source as defined in Data Sources (ODBC) control applet.

  • Disconnect -- disconnects from current database source.

Process

  • Start Process -- start the report groups and generate reports immediately.

  • Stop Process -- Stop the report groups that are running.

Options

  • Edit Setup Parameters -- Edit report groups, schedules, outputs and all parameters.

  • Clear Status Messages -- clears the status window.

  • Log Status Messages -- logs all status messages to a disk file.

Help

  • Help -- access this help system an defaults to Index tab.

  • Contents -- access this help system an defaults to Contents

  • About -- get version information for this application.


Status Window

The Status Window

The Status window gives a list of exporting events performed by the XC Export program.

This list of status messages is in time order with each entry stamped with the date and time. Newest messages will appear at the top. Scroll bars will appear as needed to allow an operator to view parts of the display that may not fit in the window.


StatusBar

The Status Bar

The Status Bar is divided in two sections. The left-hand panel displays status messages. The right-hand panel displays parameter hints.


Toolbar

The XC Reports Toolbar

The toolbar area allows you to quickly access various XC Reports Scheduler functions.

The following tools are provided:

Manually select a report group and run the report immediately.

Stop the current report schedule.

Edit the setup parameters for XC report scheduler.

Clear status messages in status windows.

Log all status messages in log file.

Open the on-line help (this document).